package com.safeway.epe;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaSparkContext;

import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class FlatMapExample {
    public static void main(String[] args) {
        Logger.getLogger("org.apache").setLevel(Level.WARN);
        List<String> stringList =  Arrays.asList(
                "WARN: TUESDAY 4 September 0540",
                "WARN: Wednesday 5 September 0541",
                "ERROR: Thursday 6 September 0542",
                "INFO: Friday 7 September 0543",
                "FATAL: Saturday 8 September 0544");
        SparkConf sparkConf = new SparkConf().setAppName("FlatMapExample").setMaster("local[*]");
        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);
        javaSparkContext.parallelize(stringList)
                .flatMap(value-> Arrays.asList(value.split(" "))
                        .iterator()).collect()
        .forEach(System.out::println);
        Scanner scanner = new Scanner(System.in);
        scanner.nextLine();
        javaSparkContext.close();
    }
}
