package com.safeway.epe;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaPairRDD;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
import scala.Tuple2;

import java.util.Arrays;
import java.util.List;

public class FluentAPIExample {
    public static void main(String[] args) {
        Logger.getLogger("org.apache").setLevel(Level.WARN);
        List<String> stringList =  Arrays.asList(
                "WARN: TUESDAY 4 September 0540",
                "WARN: Wednesday 5 September 0541",
                "ERROR: Thursday 6 September 0542",
                "INFO: Friday 7 September 0543",
                "FATAL: Saturday 8 September 0544");
        SparkConf sparkConf = new SparkConf().setAppName("RDDExample").setMaster("local[*]");
        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);
       javaSparkContext.parallelize(stringList)
                .mapToPair(value ->new Tuple2<>(value.split(":") [0] ,1L))
                .reduceByKey((value1 , value2)->value1+value2)
                .collect()
                .forEach(System.out::println);
        javaSparkContext.close();
    }
}
