package com.safeway.epe;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaPairRDD;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
import scala.Tuple2;

import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class PairRDDExample {
    public static void main(String[] args) {
        Logger.getLogger("org.apache").setLevel(Level.WARN);
        List<String> stringList =  Arrays.asList(
                "WARN: TUESDAY 4 September 0540",
                "WARN: Wednesday 5 September 0541",
                "ERROR: Thursday 6 September 0542",
                "INFO: Friday 7 September 0543",
                "FATAL: Saturday 8 September 0544");
        SparkConf sparkConf = new SparkConf().setAppName("RDDExample").setMaster("local[*]");
        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);
        JavaRDD<String> stringJavaRDD = javaSparkContext.parallelize(stringList);
        JavaPairRDD<String , String > javaPairRDD= stringJavaRDD.mapToPair(value->{
            String[]  col = value.split(":");
            String level = col[0];
            String value1 =col[1];
            return new Tuple2<String , String>(level,value1);
        });
        javaPairRDD.collect().forEach(System.out::println);

        JavaPairRDD<String , Long > javaPairRDD1= stringJavaRDD.mapToPair(value->{
            String[]  col = value.split(":");
            String level = col[0];
            return new Tuple2<String , Long>(level,1L);
        });
        JavaPairRDD<String , Long> countWithKey = javaPairRDD1.reduceByKey((value1 , value2) ->value1+value2);
        countWithKey.collect().forEach(System.out::println);
        Scanner scanner = new Scanner(System.in);
        scanner.nextLine();
        javaSparkContext.close();
    }
}
