package com.safeway.epe;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;


import java.io.Serializable;
import java.util.Arrays;
import java.util.List;


public class RDDSetup implements Serializable {
    public static void main(String[] args) {
        Logger.getLogger("org.apache").setLevel(Level.WARN);
        List<Integer> integerList = Arrays.asList(2,4,3,5,11,44,22);
        SparkConf sparkConf = new SparkConf().setAppName("RDDExample").setMaster("local[*]");
        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);
        JavaRDD<Integer> integerJavaRDD = javaSparkContext.parallelize(integerList);
        Integer value  = integerJavaRDD.reduce((Integer i, Integer j) ->i+j );
        JavaRDD<Double> doubleList = integerJavaRDD.map(value1->Math.sqrt(value1));
        doubleList.foreach(value1-> System.out.println(value1));
        doubleList.collect().forEach(System.out::println);
        System.out.println(value);
        javaSparkContext.close();
    }
}
