package com.safeway.epe;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
import scala.Tuple2;

import java.util.Arrays;
import java.util.List;

public class TuppleExample {
    public static void main(String[] args) {
        Logger.getLogger("org.apache").setLevel(Level.WARN);
        List<Integer> integerList = Arrays.asList(2,4,3,5,11,44,22);
        List<String> stringList =  Arrays.asList(
                "WARN: TUESDAY 4 September 0540",
                "WARN: Wednesday 5 September 0541",
                "ERROR: Thursday 6 September 0542",
                "INFO: Friday 7 September 0543",
                "FATAL: Saturday 8 September 0544");

        SparkConf sparkConf = new SparkConf().setAppName("RDDExample").setMaster("local[*]");
        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);
        JavaRDD<Integer> integerJavaRDD = javaSparkContext.parallelize(integerList);
        JavaRDD<Double> doubleList = integerJavaRDD.map(value1->Math.sqrt(value1));
        JavaRDD<Tuple2<Integer , Double>> tuple2JavaRDD= integerJavaRDD.map(val->new Tuple2<>(val , Math.sqrt(val)));
        //JavaRDD<Tuple2<Integer , Double>> myValue =  new Tuple2(integerJavaRDD ,doubleList);
        tuple2JavaRDD.collect().forEach(System.out::println);
        JavaRDD<String> stringJavaRDD = javaSparkContext.parallelize(stringList);
    }
}
